from Carbon.File import FSRef, FSGetDataForkName
from Carbon.Files import fsRdPerm
from Carbon import Res
import Image, struct, math # all for pxm# extracting
import os, sys

path = sys.argv[1]
fsRef = FSRef(path)
resNum = Res.FSOpenResourceFile(fsRef, FSGetDataForkName(), fsRdPerm)
Res.SetResLoad(True)
knownTypes = ("PICT", "PNG ", "PNGf", "pxm#")
unknownTypes = []
while True:
    Res.UseResFile(resNum)
    for typeIndex in xrange(1, Res.Count1Types()+1):
        resType = Res.Get1IndType(typeIndex)
        if (resType not in knownTypes) and (resType not in unknownTypes):
            unknownTypes.append(resType)
            print >> sys.stderr, "unknown resource type", resType
        for resIndex in xrange(1, Res.Count1Resources(resType)+1):
            try:
                r = Res.Get1IndResource(resType, resIndex)
            except Exception:
                print >> sys.stderr, "error opening resource type", resType, "index", resIndex
                continue
            id, thisResType, name = r.GetResInfo()
            name = name.decode("macroman")
            if thisResType in knownTypes:                    
                if thisResType == "pxm#":
                    print >> sys.stderr, "extracting pxm# id", id, "name", name
                    version, = struct.unpack("<h", r.data[:2])
                    if version == 3:
                        endian = "<"
                    elif version == 0x0300:
                        endian = ">"
                    else:
                        print >> sys.stderr, "old version", version
                        continue
                    bitfield, \
                    boundsX, boundsY, height, width, \
                    pixelSize, pixelType, \
                    imageCount = struct.unpack(endian+"HhhhhHH6xH", r.data[2:24])
                    if (boundsX != 0) or (boundsY != 0):
                        print >> sys.stderr, "non-zero bounding origin!"
                        continue
                    if pixelSize != 32:
                        print >> sys.stderr, "unsupported pixel size", pixelSize
                        continue
                    if pixelType != 32:
                        print >> sys.stderr, "unsupported pixel type", pixelType
                        continue
                    if pixelSize != pixelType:
                        print >> sys.stderr, "pixel size and type don't match"
                        continue
                    if not (bitfield & 0b0100): # has alpha
                        print >> sys.stderr, "32-bit pxm# doesn't have alpha!"
                        continue
                    if bitfield & 0b0001: # single mask
                        pxmReadPointer = 24+int(math.ceil((width*height)/8.0))
                    else:
                        pxmReadPointer = 24+int(math.ceil((width*height)/8.0)*imageCount)
                    pxmReadPointer = len(r.data)-(width*height*4*imageCount)
                    for imgNum in xrange(imageCount):
                        im = Image.new("RGBA", (width, height))
                        for y in xrange(height):
                            for x in xrange(width):
                                pixel = struct.unpack(endian+"BBBB", r.data[pxmReadPointer:pxmReadPointer+4])
                                pxmReadPointer += 4
                                im.putpixel((x, y), pixel)
                        
                        if name:
                            fname = "%s (%d) %d.png" % (name.replace(os.path.sep,
                                                                 "%%%02X" % ord(os.path.sep)),
                                                        id, imgNum)
                        else:
                            fname = "%d %d.png" % (id, imgNum)
                        
                        im.save(fname)
                else:
                    if thisResType.startswith("PNG"):
                        extension = "png"
                    else:
                        extension = thisResType
                    if name:
                        fname = "%s (%d).%s" % (name.replace(os.path.sep,
                                                             "%%%02X" % ord(os.path.sep)),
                                                id,
                                                extension)
                    else:
                        fname = "%d.%s" % (id, extension)
                    f = open(fname, 'wb')
                    f.write(r.data)
                    f.close()
    try:
        resNum = Res.GetNextResourceFile(resNum)
    except:
        break
Res.CloseResFile(resNum)